﻿using System.IO;
using System.IO.MemoryMappedFiles;
using System.Runtime.InteropServices;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            string mapFilePath   = "d:\\ExtremelyLargeImage.data";
            string mapName       = "testMap";
            long   dataOffset    = 0x10000000; // 256MB
            long   dataLength    = 0x20000000; // 512MB
            long   mapFileLength = 0x40000000; // 1GB

            if(!File.Exists(mapFilePath))
            {
                using(MemoryMappedFile file = MemoryMappedFile.CreateFromFile(mapFilePath, FileMode.CreateNew, mapName, mapFileLength))
                {
                }
            }

            using(MemoryMappedFile file = MemoryMappedFile.CreateFromFile(mapFilePath, FileMode.Open, mapName))
            {
                using(MemoryMappedViewAccessor accessor = file.CreateViewAccessor(dataOffset, dataLength))
                {
                    int colorSize = Marshal.SizeOf(typeof(CustomColor));

                    for (long i = 0; i < dataLength; i += colorSize)
                    {
                        accessor.Read(i, out CustomColor color);

                        color.Brighten(10);

                        accessor.Write(i, ref color);
                    }
                }
            }
        }

        #endregion
    }
}